#![feature(try_blocks, async_closure)]
#![cfg_attr(target_os = "windows", windows_subsystem = "windows")]

use crate::app::App;

mod app;
mod config;
mod splits_logic;

#[cfg(not(target_arch = "wasm32"))]
fn main() {
    let runtime = tokio::runtime::Builder::new_multi_thread()
        .enable_all()
        .build()
        .unwrap();
    runtime.block_on(async {
        let app = App::default();
        let native_options = eframe::NativeOptions::default();
        eframe::run_native(Box::new(app), native_options);
    });
}
